## magma 0.2.1-1

=== DESCRIPTION ===
Package: magma
Title: Matrix Algebra on GPU and Multicore Arcitectures
Version: 0.2.1-1
Date: 2010-08-09
Author: Brian J Smith <brian-j-smith@uiowa.edu>
Maintainer: Brian J Smith <brian-j-smith@uiowa.edu>
Depends: R (>= 2.10.0), methods
SystemRequirements: nVidia CUDA toolkit (>= release 3.0), LAPACK shared
        library, MAGMA shared libraries (== release 0.2)
Description: Magma matrix classes and methods for parallel processing
        of matrix algebra operations.  Operations are performed with
        algorithms developed by the MAGMA research project.  MAGMA aims
        to acheive the fastest possible linear algebra libraries on
        hybrid mutlicore CPU and GPU architectures by exploiting their
        massive parallelism and minimizeing communication latencies.
URL: http://icl.cs.utk.edu/magma
License: GPL (>= 2)
Packaged: 2010-08-09 14:22:20 UTC; bjsmith
Repository: CRAN
Date/Publication: 2010-08-11 04:58:32
OS_type: unix

## magma 0.2.1-2

=== DESCRIPTION ===
Package: magma
Title: Matrix Algebra on GPU and Multicore Architectures
Version: 0.2.1-2
Date: 2010-08-13
Author: Brian J Smith <brian-j-smith@uiowa.edu>
Maintainer: Brian J Smith <brian-j-smith@uiowa.edu>
Depends: R (>= 2.10.0), methods
SystemRequirements: MAGMA shared libraries (== release 0.2), LAPACK
        shared library, NVIDIA CUDA Toolkit (>= release 3.0)
Description: Magma matrix classes and methods for parallel processing
        of matrix algebra operations.  Operations are performed with
        algorithms developed by the MAGMA research project.  MAGMA aims
        to achieve the fastest possible linear algebra libraries on
        hybrid multicore CPU and GPU architectures by exploiting their
        massive parallelism and minimizing communication latencies.
License: GPL (>= 3)
URL: http://icl.cs.utk.edu/magma
OS_type: unix
Packaged: 2010-08-13 12:38:36 UTC; bjsmith
Repository: CRAN
Date/Publication: 2010-08-13 18:31:02

## magma 0.2.1-3

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: magma
 Title: Matrix Algebra on GPU and Multicore Architectures
-Version: 0.2.1-2
-Date: 2010-08-13
+Version: 0.2.1-3
+Date: 2010-08-20
 Author: Brian J Smith <brian-j-smith@uiowa.edu>
 Maintainer: Brian J Smith <brian-j-smith@uiowa.edu>
 Depends: R (>= 2.10.0), methods
@@ -16,6 +16,6 @@
 License: GPL (>= 3)
 URL: http://icl.cs.utk.edu/magma
 OS_type: unix
-Packaged: 2010-08-13 12:38:36 UTC; bjsmith
+Packaged: 2010-08-20 13:23:04 UTC; bjsmith
 Repository: CRAN
-Date/Publication: 2010-08-13 18:31:02
+Date/Publication: 2010-08-20 20:29:53

## magma 0.2.2-1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: magma
 Title: Matrix Algebra on GPU and Multicore Architectures
-Version: 0.2.1-3
-Date: 2010-08-20
+Version: 0.2.2-1
+Date: 2010-08-27
 Author: Brian J Smith <brian-j-smith@uiowa.edu>
 Maintainer: Brian J Smith <brian-j-smith@uiowa.edu>
 Depends: R (>= 2.10.0), methods
@@ -16,6 +16,6 @@
 License: GPL (>= 3)
 URL: http://icl.cs.utk.edu/magma
 OS_type: unix
-Packaged: 2010-08-20 13:23:04 UTC; bjsmith
+Packaged: 2010-08-27 13:21:44 UTC; bjsmith
 Repository: CRAN
-Date/Publication: 2010-08-20 20:29:53
+Date/Publication: 2010-08-27 13:36:31

## magma 0.trunk20040913

=== lib/Makefile ===
###############################################################################
###############################################################################
##
##  Copyright (C) 2004 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
top_srcdir=..
include ${top_srcdir}/make/defines.mk
UNINSTALL = ${top_srcdir}/scripts/uninstall.pl

TARGETS=libmagma.a \
	libmagmamsg.a \
	libmagma.so.$(RELEASE_MAJOR).$(RELEASE_MINOR) \
	libmagma.so.$(RELEASE_MAJOR) \
	libmagmamsg.so.$(RELEASE_MAJOR).$(RELEASE_MINOR) \
	libmagmamsg.so.$(RELEASE_MAJOR) \
	libmagma.so \
	libmagmamsg.so

INCLUDE=-I.
CFLAGS+=-g -Werror -Wstrict-prototypes -Wshadow \
	-fPIC -DPLUGINDIR=\"${libdir}/magma/plugins\" \
	-D_GNU_SOURCE

all: $(TARGETS)

clean:
	rm -f *o *~ *.a $(TARGETS)

install: all
	install -d $(libdir)
	install -m 0644 libmagma.a libmagmamsg.a $(libdir)
	install -m 0644 libmagma.so.$(RELEASE_MAJOR).$(RELEASE_MINOR) $(libdir)
	cd $(libdir); ln -snf libmagma.so.$(RELEASE_MAJOR).$(RELEASE_MINOR) libmagma.so.$(RELEASE_MAJOR); cd -
	cd $(libdir); ln -snf libmagma.so.$(RELEASE_MAJOR).$(RELEASE_MINOR) libmagma.so; cd -
	install -m 0644 libmagmamsg.so.$(RELEASE_MAJOR).$(RELEASE_MINOR) $(libdir)
	cd $(libdir); ln -snf libmagmamsg.so.$(RELEASE_MAJOR).$(RELEASE_MINOR) libmagmamsg.so.$(RELEASE_MAJOR); cd -
	cd $(libdir); ln -snf libmagmamsg.so.$(RELEASE_MAJOR).$(RELEASE_MINOR) libmagmamsg.so; cd -
	install -d ${incdir}
	install -m 0644 magma.h $(incdir)
	install -m 0644 magmamsg.h $(incdir)
	install -m 0644 magma-build.h $(incdir)	

uninstall:
	${UNINSTALL} ${TARGETS} ${libdir}
	${UNINSTALL} magma.h magmamsg.h magma-build.h ${incdir}

libmagma.so: libmagma.so.$(RELEASE_MAJOR).$(RELEASE_MINOR)
	ln -snf $^ $@

libmagmamsg.so: libmagmamsg.so.$(RELEASE_MAJOR).$(RELEASE_MINOR)
	ln -snf $^ $@

libmagma.so.$(RELEASE_MAJOR): libmagma.so.$(RELEASE_MAJOR).$(RELEASE_MINOR)
	ln -snf $^ $@

libmagmamsg.so.$(RELEASE_MAJOR): libmagmamsg.so.$(RELEASE_MAJOR).$(RELEASE_MINOR)
	ln -snf $^ $@

libmagma.so.$(RELEASE_MAJOR).$(RELEASE_MINOR): global.o plugin.o localinfo.o ip_lookup.o \
		        memberlist.o clist.o
	${LD} -shared -soname libmagma.so.$(RELEASE_MAJOR) -o $@ $^ -lc

libmagmamsg.so.$(RELEASE_MAJOR).$(RELEASE_MINOR): message.o fdops.o
	${LD} -shared -soname libmagmamsg.so.$(RELEASE_MAJOR) -o $@ $^ -lc

libmagma.a: global.o plugin.o localinfo.o ip_lookup.o \
		        memberlist.o clist.o
	${AR} cr $@ $^

libmagmamsg.a: message.o fdops.o
	${AR} cr $@ $^

%.o: %.c
	$(CC) -c -o $@ $^ $(INCLUDE) $(CFLAGS) -D_CLUSTER_

=== man/Makefile ===
###############################################################################
###############################################################################
##
##  Copyright (C) 2004 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
top_srcdir=..
include ${top_srcdir}/make/defines.mk
UNINSTALL = ${top_srcdir}/scripts/uninstall.pl

install:
	install -d ${mandir}/man3
	install clu_connect.3 clu_disconnect.3 clu_get_event.3 ${mandir}/man3

uninstall:
	${UNINSTALL} clu_connect.3 clu_disconnect.3 clu_get_event.3 ${mandir}/man3

=== tests/Makefile ===
###############################################################################
###############################################################################
##
##  Copyright (C) 2004 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
top_srcdir=..
include ${top_srcdir}/make/defines.mk
UNINSTALL=${top_srcdir}/scripts/uninstall.pl

INCLUDE+= -I${top_srcdir}/lib
LIBS     = -L${top_srcdir}/lib -lmagma -lmagmamsg -ldl -lpthread
TARGETS  = cpt cptester circleping cluster_cmd
CFLAGS  += -DDEBUG

all: $(TARGETS)

install: all
	install -d ${sbindir}
	install -m 0755 $(TARGETS) ${sbindir}

uninstall:
	${UNINSTALL} ${TARGETS} ${sbindir}

circleping: circleping.o
	$(CC) -o $@ $^ $(LIBS) -ggdb

cluster_cmd: cluster_cmd.o
	$(CC) -o $@ $^ $(LIBS)

cpt: cpt.o
	$(CC) -o $@ $^ $(LIBS) -ggdb

cptester: cptester.o
	$(CC) -o $@ $^ $(LIBS)

%.o: %.c
	$(CC) -c -o $@ $^ $(INCLUDES) $(CFLAGS) -ggdb

clean:
	rm -f *o *~ *.so $(TARGETS)

## magma 1.3.0-2

=== DESCRIPTION ===
Package: magma
Title: Matrix Algebra on GPU and Multicore Architectures
Version: 1.3.0-2
Date: 2013-04-03
Author: Brian J Smith <brian-j-smith@uiowa.edu>
Maintainer: Brian J Smith <brian-j-smith@uiowa.edu>
Depends: R (>= 2.11.0), methods
SystemRequirements: MAGMA shared libraries (== release 1.3.0), LAPACK
        shared library, NVIDIA CUDA Toolkit (>= release 4.0)
Description: Magma matrix classes and methods for parallel processing
        of matrix algebra operations.  Operations are performed with
        algorithms developed by the MAGMA research project.  MAGMA aims
        to achieve the fastest possible linear algebra libraries on
        hybrid multicore CPU and GPU architectures by exploiting their
        massive parallelism and minimizing communication latencies.
License: GPL-3
URL: http://icl.cs.utk.edu/magma
OS_type: unix
Packaged: 2013-04-03 11:59:56 UTC; bjsmith
NeedsCompilation: yes
Repository: CRAN
Date/Publication: 2013-04-03 16:15:34

## magma 2.5.4+ds

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 2.8.1 )

# ----------------------------------------
# to disable Fortran, set this to "off"
# see also -DADD_ below
option( USE_FORTRAN "Fortran is required for some tester checks, but can be disabled with reduced functionality" ON )

if (USE_FORTRAN)
    project( MAGMA C CXX Fortran )
else()
    project( MAGMA C CXX )
endif()


# ----------------------------------------
# to show compile commands, set this here or use 'make VERBOSE=1'
#set(CMAKE_VERBOSE_MAKEFILE on)


# ----------------------------------------
# don't regenerate files during make.
# (I think this means you have to manually re-run CMake if CMakeLists changes.
# It fixes the huge problems with CMake interrupting Visual Studio.)
set(CMAKE_SUPPRESS_REGENERATION on)


# ----------------------------------------
# force an out-of-source build, to not overwrite the existing Makefiles
# (out-of-source is cleaner, too)
string( COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" MAGMA_COMPILE_INPLACE )
if (MAGMA_COMPILE_INPLACE)
    message( FATAL_ERROR "Compiling MAGMA with CMake requires an out-of-source build. To proceed:
    rm -rf CMakeCache.txt CMakeFiles/   # delete files in ${CMAKE_SOURCE_DIR}
    mkdir build
    cd build
    cmake ..
    make" )
endif()


# ----------------------------------------
# prefer shared libraries
option( BUILD_SHARED_LIBS "If on, build shared libraries, otherwise build static libraries" ON )

# prefer /usr/local/magma, instead of /usr/local.
if (UNIX AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "/usr/local/magma" CACHE PATH "..." FORCE)
endif()

# ----------------------------------------
# use C++11 and C99
# see http://stackoverflow.com/questions/10851247/how-to-activate-c-11-in-cmake
include(CheckCXXCompilerFlag)
include(CheckCCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
if (COMPILER_SUPPORTS_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
elseif(COMPILER_SUPPORTS_CXX0X)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
else()
    message( WARNING "The compiler ${CMAKE_CXX_COMPILER} doesn't support the -std=c++11 flag. Some code may not compile.")
endif()

CHECK_C_COMPILER_FLAG("-std=c99" COMPILER_SUPPORTS_C99)
if (COMPILER_SUPPORTS_C99)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
else()
    message( WARNING "The compiler ${CMAKE_C_COMPILER} doesn't support the -std=c99 flag. Some code may not compile.")
endif()


# ----------------------------------------
# check Fortran name mangling
if (USE_FORTRAN)
    include( FortranCInterface )
    FortranCInterface_HEADER( ${CMAKE_SOURCE_DIR}/include/magma_mangling_cmake.h MACRO_NAMESPACE MAGMA_ )
else()
    # set one of -DADD_, -DUPCASE, or -DNOCHANGE. See README.
    message( STATUS "Building without Fortran compiler" )
    set( FORTRAN_CONVENTION "-DADD_" CACHE STRING "Fortran calling convention, one of -DADD_, -DNOCHANGE, -DUPCASE" )
    set_property( CACHE FORTRAN_CONVENTION PROPERTY STRINGS -DADD_ -DNOCHANGE -DUPCASE )
    message( STATUS "    Using ${FORTRAN_CONVENTION} for Fortran calling convention" )
    set( CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   ${FORTRAN_CONVENTION}" )
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FORTRAN_CONVENTION}" )
    # see also NVCC_FLAGS below
endif()


# ----------------------------------------
# locate OpenMP
find_package( OpenMP )
if (OPENMP_FOUND)
    message( STATUS "Found OpenMP" )
    message( STATUS "    OpenMP_C_FLAGS   ${OpenMP_C_FLAGS}" )
    message( STATUS "    OpenMP_CXX_FLAGS ${OpenMP_CXX_FLAGS}" )
    set( CMAKE_C_FLAGS   "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}" )
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}" )
endif()


# ----------------------------------------
# locate CUDA libraries
set( GPU_TARGET "Kepler Maxwell Pascal" CACHE STRING "CUDA architectures to compile for; one or more of Fermi, Kepler, Maxwell, Pascal, Volta, Turing, Ampere, or valid sm_[0-9][0-9]" )
find_package( CUDA )
if (CUDA_FOUND)
    message( STATUS "Found CUDA ${CUDA_VERSION}" )
    message( STATUS "    CUDA_INCLUDE_DIRS:   ${CUDA_INCLUDE_DIRS}"   )
    message( STATUS "    CUDA_CUDART_LIBRARY: ${CUDA_CUDART_LIBRARY}" )
    #message( STATUS "    CUDA_LIBRARIES: ${CUDA_LIBRARIES}" )
    #message( STATUS "    CUDA_CUBLAS_LIBRARIES: ${CUDA_CUBLAS_LIBRARIES}" )
    include_directories( ${CUDA_INCLUDE_DIRS} )

    # NVCC options for the different cards
    # sm_xx is binary, compute_xx is PTX for forward compatability
    # MIN_ARCH is lowest requested version
    # NV_SM    accumulates sm_xx for all requested versions
    # NV_COMP  is compute_xx for highest requested version
    set( NV_SM    "" )
    set( NV_COMP  "" )

    set(CUDA_SEPARABLE_COMPILATION ON)

    # nvcc >= 6.5 supports -std=c++11, so propagate CXXFLAGS to NVCCFLAGS.
    # Older nvcc didn't support -std=c++11, so previously we disabled propagation.
    ##if (${CMAKE_CXX_FLAGS} MATCHES -std=)
    ##    set( CUDA_PROPAGATE_HOST_FLAGS OFF )
    ##endif()

    if (GPU_TARGET MATCHES Fermi)
        set( GPU_TARGET "${GPU_TARGET} sm_20" )
    endif()

    if (GPU_TARGET MATCHES Kepler)
        set( GPU_TARGET "${GPU_TARGET} sm_30 sm_35" )
    endif()

    if (GPU_TARGET MATCHES Maxwell)
        set( GPU_TARGET "${GPU_TARGET} sm_50" )
    endif()

    if (GPU_TARGET MATCHES Pascal)
        set( GPU_TARGET "${GPU_TARGET} sm_60" )
    endif()

    if (GPU_TARGET MATCHES Volta)
        set( GPU_TARGET "${GPU_TARGET} sm_70" )
    endif()

    if (GPU_TARGET MATCHES Turing)
        set( GPU_TARGET "${GPU_TARGET} sm_75" )
    endif()

    if (GPU_TARGET MATCHES Ampere)
        set( GPU_TARGET "${GPU_TARGET} sm_80" )
    endif()

    if (GPU_TARGET MATCHES sm_20)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 200 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_20,code=sm_20 )
        set( NV_COMP        -gencode arch=compute_20,code=compute_20 )
        message( STATUS "    compile for CUDA arch 2.0 (Fermi)" )
    endif()

    if (GPU_TARGET MATCHES sm_30)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 300 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_30,code=sm_30 )
        set( NV_COMP        -gencode arch=compute_30,code=compute_30 )
        message( STATUS "    compile for CUDA arch 3.0 (Kepler)" )
    endif()

    if (GPU_TARGET MATCHES sm_35)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 300 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_35,code=sm_35 )
        set( NV_COMP        -gencode arch=compute_35,code=compute_35 )
        message( STATUS "    compile for CUDA arch 3.5 (Kepler)" )
    endif()

    if (GPU_TARGET MATCHES sm_50)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 500 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_50,code=sm_50 )
        set( NV_COMP        -gencode arch=compute_50,code=compute_50 )
        message( STATUS "    compile for CUDA arch 5.0 (Maxwell)" )
    endif()

    if (GPU_TARGET MATCHES sm_52)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 520 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_52,code=sm_52 )
        set( NV_COMP        -gencode arch=compute_52,code=compute_52 )
        message( STATUS "    compile for CUDA arch 5.2 (Maxwell)" )
    endif()

    if (GPU_TARGET MATCHES sm_53)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 530 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_53,code=sm_53 )
        set( NV_COMP        -gencode arch=compute_53,code=compute_53 )
        message( STATUS "    compile for CUDA arch 5.3 (Maxwell)" )
    endif()

    if (GPU_TARGET MATCHES sm_60)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 600 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_60,code=sm_60 )
        set( NV_COMP        -gencode arch=compute_60,code=compute_60 )
        message( STATUS "    compile for CUDA arch 6.0 (Pascal)" )
    endif()

    if (GPU_TARGET MATCHES sm_61)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 610 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_61,code=sm_61 )
        set( NV_COMP        -gencode arch=compute_61,code=compute_61 )
        message( STATUS "    compile for CUDA arch 6.1 (Pascal)" )
    endif()

    if (GPU_TARGET MATCHES sm_62)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 620 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_62,code=sm_62 )
        set( NV_COMP        -gencode arch=compute_62,code=compute_62 )
        message( STATUS "    compile for CUDA arch 6.2 (Pascal)" )
    endif()

    if (GPU_TARGET MATCHES sm_70)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 700 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_70,code=sm_70 )
        set( NV_COMP        -gencode arch=compute_70,code=compute_70 )
        message( STATUS "    compile for CUDA arch 7.0 (Volta)" )
    endif()

    if (GPU_TARGET MATCHES sm_71)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 710 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_71,code=sm_71 )
        set( NV_COMP        -gencode arch=compute_71,code=compute_71 )
        message( STATUS "    compile for CUDA arch 7.1 (Volta)" )
    endif()

    if (GPU_TARGET MATCHES sm_75)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 750 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_75,code=sm_75 )
        set( NV_COMP        -gencode arch=compute_75,code=compute_75 )
        message( STATUS "    compile for CUDA arch 7.5 (Turing)" )
    endif()

    if (GPU_TARGET MATCHES sm_80)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 800 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_80,code=sm_80 )
        set( NV_COMP        -gencode arch=compute_80,code=compute_80 )
        message( STATUS "    compile for CUDA arch 8.0 (Ampere)" )
    endif()

    if (NOT MIN_ARCH)
        message( FATAL_ERROR "GPU_TARGET must contain one or more of Fermi, Kepler, Maxwell, Pascal, Volta, Turing, Ampere, or valid sm_[0-9][0-9]" )
    endif()

    set( CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS} -Xcompiler -fPIC -DHAVE_CUBLAS ${NV_SM} ${NV_COMP} ${FORTRAN_CONVENTION} )
    add_definitions( "-DHAVE_CUBLAS -DMIN_CUDA_ARCH=${MIN_ARCH}" )
    message( STATUS "Define -DHAVE_CUBLAS -DMIN_CUDA_ARCH=${MIN_ARCH}" )
endif()


# ----------------------------------------
# locate LAPACK libraries

set(BLA_VENDOR "" CACHE STRING
    "Use specified BLAS library. See https://cmake.org/cmake/help/latest/module/FindBLAS.html")

# List from CMake 3.17, minus some obsolete ones:
# PhiPACK, Compaq CXML, DEC Alpha DXML, SunPerf, SGI SCSL, SGIMATH,
# Intel, NAS (Apple veclib).
# FLAME is BLIS.
set_property(CACHE BLA_VENDOR PROPERTY STRINGS
    "" "All" "Goto" "OpenBLAS" "FLAME" "ATLAS" "IBMESSL"
    "Intel10_64lp" "Intel10_64lp_seq" "Intel10_64ilp" "Intel10_64ilp_seq"
    "ACML" "ACML_MP" "ACML_GPU"
    "Apple"
    "Arm" "Arm_mp" "Arm_ilp64" "Arm_ilp64_mp"
    "Generic")

set( LAPACK_LIBRARIES "" CACHE STRING "Libraries for LAPACK and BLAS, to manually override search" )
if (LAPACK_LIBRARIES STREQUAL "")
    message( STATUS "Searching for BLAS and LAPACK. To override, set LAPACK_LIBRARIES using ccmake." )
    find_package( LAPACK )
    # force showing updated LAPACK_LIBRARIES in ccmake / cmake-gui.
    set( LAPACK_LIBRARIES ${LAPACK_LIBRARIES} CACHE STRING "Libraries for LAPACK and BLAS, to manually override search" FORCE )
else()
    message( STATUS "User set LAPACK_LIBRARIES. To change, edit LAPACK_LIBRARIES using ccmake (set to empty to enable search)." )
    # Check either -lname syntax or file existence
    foreach( LIB ${LAPACK_LIBRARIES} )
        if (NOT LIB MATCHES "^-l[a-zA-Z0-9_-]+$")
        if (NOT EXISTS ${LIB})
            message( WARNING "\n      Warning: file ${LIB} does not exist.\n" )
        endif()
        endif()
    endforeach()
endif()

=== Makefile ===
# ------------------------------------------------------------------------------
# programs
#
# Users should make all changes in make.inc
# It should not be necesary to change anything in here.

include make.inc

# defaults if nothing else is given in make.inc
CC         ?= cc
CXX        ?= c++
NVCC       ?= nvcc
FORT       ?=
ifeq ($(FORT),)
    $(warning No Fortran compiler was given in FORT in make.inc. Some testers will not be able to check their results.)
endif

ARCH       ?= ar
ARCHFLAGS  ?= cr
RANLIB     ?= ranlib

# shared libraries require -fPIC
#FPIC       = -fPIC

# may want -std=c99 for CFLAGS, -std=c++11 for CXXFLAGS
CFLAGS     ?= -O3 $(FPIC) -DADD_ -Wall -MMD
CXXFLAGS   ?= $(CFLAGS) -std=c++11
NVCCFLAGS  ?= -O3         -DADD_ -Xcompiler "$(FPIC) -Wall -Wno-unused-function" -std=c++11
FFLAGS     ?= -O3 $(FPIC) -DADD_ -Wall -Wno-unused-dummy-argument
F90FLAGS   ?= -O3 $(FPIC) -DADD_ -Wall -Wno-unused-dummy-argument
LDFLAGS    ?= -O3 $(FPIC)

INC        ?= -I$(CUDADIR)/include

LIBDIR     ?= -L$(CUDADIR)/lib64
LIB        ?= -lcudart -lcudadevrt -lcublas -lcusparse -llapack -lblas -lpthread -lm

GPU_TARGET ?= Kepler Maxwell Pascal

# Extension for object files: o for unix, obj for Windows?
o_ext      ?= o

prefix     ?= /usr/local/magma


# ------------------------------------------------------------------------------
# MAGMA-specific programs & flags

ifeq ($(blas_fix),1)
    # prepend -lblas_fix to LIB (it must come before LAPACK library/framework)
    LIB := -lblas_fix $(LIB)
endif

LIBS       = $(LIBDIR) $(LIB)

# preprocessor flags. See below for MAGMA_INC
CPPFLAGS   = $(INC) $(MAGMA_INC)

CFLAGS    += -DHAVE_CUBLAS
CXXFLAGS  += -DHAVE_CUBLAS

# where testers look for MAGMA libraries
RPATH      = -Wl,-rpath,${abspath ./lib}

codegen    = python tools/codegen.py


# ------------------------------------------------------------------------------
# NVCC options for the different cards
# First, add smXX for architecture names
ifneq ($(findstring Kepler, $(GPU_TARGET)),)
    GPU_TARGET += sm_30 sm_35
endif
ifneq ($(findstring Maxwell, $(GPU_TARGET)),)
    GPU_TARGET += sm_50
endif
ifneq ($(findstring Pascal, $(GPU_TARGET)),)
    GPU_TARGET += sm_60
endif
ifneq ($(findstring Volta, $(GPU_TARGET)),)
    GPU_TARGET += sm_70
endif
ifneq ($(findstring Turing, $(GPU_TARGET)),)
    GPU_TARGET += sm_75
endif
ifneq ($(findstring Ampere, $(GPU_TARGET)),)
    GPU_TARGET += sm_80
endif
# Remember to add to CMakeLists.txt too!


# Next, add compile options for specific smXX
# sm_xx is binary, compute_xx is PTX for forward compatability
# MIN_ARCH is lowest requested version
#          Use it ONLY in magma_print_environment; elsewhere use __CUDA_ARCH__ or magma_getdevice_arch()
# NV_SM    accumulates sm_xx for all requested versions
# NV_COMP  is compute_xx for highest requested version
#
# See also $(info compile for ...) in Makefile
NV_SM    :=
NV_COMP  :=

ifneq ($(findstring sm_10, $(GPU_TARGET)),)
    $(warning CUDA arch 1.x is no longer supported by CUDA >= 6.x and MAGMA >= 2.0)
endif
ifneq ($(findstring sm_13, $(GPU_TARGET)),)
    $(warning CUDA arch 1.x is no longer supported by CUDA >= 6.x and MAGMA >= 2.0)
endif
ifneq ($(findstring sm_20, $(GPU_TARGET)),)
    MIN_ARCH ?= 200
    NV_SM    += -gencode arch=compute_20,code=sm_20
    NV_COMP  := -gencode arch=compute_20,code=compute_20
    $(warning CUDA arch 2.x is no longer supported by CUDA >= 9.x)
endif
ifneq ($(findstring sm_30, $(GPU_TARGET)),)
    MIN_ARCH ?= 300
    NV_SM    += -gencode arch=compute_30,code=sm_30
    NV_COMP  := -gencode arch=compute_30,code=compute_30
endif
ifneq ($(findstring sm_32, $(GPU_TARGET)),)
    MIN_ARCH ?= 320
    NV_SM    += -gencode arch=compute_32,code=sm_32
    NV_COMP  := -gencode arch=compute_32,code=compute_32
endif
ifneq ($(findstring sm_35, $(GPU_TARGET)),)
    MIN_ARCH ?= 350
    NV_SM    += -gencode arch=compute_35,code=sm_35
    NV_COMP  := -gencode arch=compute_35,code=compute_35
endif
ifneq ($(findstring sm_50, $(GPU_TARGET)),)
    MIN_ARCH ?= 500
    NV_SM    += -gencode arch=compute_50,code=sm_50
    NV_COMP  := -gencode arch=compute_50,code=compute_50
endif
ifneq ($(findstring sm_52, $(GPU_TARGET)),)
    MIN_ARCH ?= 520
    NV_SM    += -gencode arch=compute_52,code=sm_52
    NV_COMP  := -gencode arch=compute_52,code=compute_52
endif
ifneq ($(findstring sm_53, $(GPU_TARGET)),)
    MIN_ARCH ?= 530
    NV_SM    += -gencode arch=compute_53,code=sm_53
    NV_COMP  := -gencode arch=compute_53,code=compute_53
endif
ifneq ($(findstring sm_60, $(GPU_TARGET)),)
    MIN_ARCH ?= 600
    NV_SM    += -gencode arch=compute_60,code=sm_60
    NV_COMP  := -gencode arch=compute_60,code=compute_60
endif
ifneq ($(findstring sm_61, $(GPU_TARGET)),)
    MIN_ARCH ?= 610
    NV_SM    += -gencode arch=compute_61,code=sm_61
    NV_COMP  := -gencode arch=compute_61,code=compute_61
endif
ifneq ($(findstring sm_62, $(GPU_TARGET)),)
    MIN_ARCH ?= 620
    NV_SM    += -gencode arch=compute_62,code=sm_62
    NV_COMP  := -gencode arch=compute_62,code=compute_62
endif
ifneq ($(findstring sm_70, $(GPU_TARGET)),)
    MIN_ARCH ?= 700
    NV_SM    += -gencode arch=compute_70,code=sm_70
    NV_COMP  := -gencode arch=compute_70,code=compute_70
endif
ifneq ($(findstring sm_71, $(GPU_TARGET)),)
    MIN_ARCH ?= 710
    NV_SM    += -gencode arch=compute_71,code=sm_71
    NV_COMP  := -gencode arch=compute_71,code=compute_71
endif
ifneq ($(findstring sm_75, $(GPU_TARGET)),)
    MIN_ARCH ?= 750
    NV_SM    += -gencode arch=compute_75,code=sm_75
    NV_COMP  := -gencode arch=compute_75,code=compute_75
endif
ifneq ($(findstring sm_80, $(GPU_TARGET)),)
    MIN_ARCH ?= 800
    NV_SM    += -gencode arch=compute_80,code=sm_80
    NV_COMP  := -gencode arch=compute_80,code=compute_80
endif
ifeq ($(NV_COMP),)
    $(error GPU_TARGET, currently $(GPU_TARGET), must contain one or more of Fermi, Kepler, Maxwell, Pascal, Volta, Turing, Ampere, or valid sm_[0-9][0-9]. Please edit your make.inc file)
endif
NVCCFLAGS += $(NV_SM) $(NV_COMP)
CFLAGS    += -DMIN_CUDA_ARCH=$(MIN_ARCH)
CXXFLAGS  += -DMIN_CUDA_ARCH=$(MIN_ARCH)


# ------------------------------------------------------------------------------
# Define the pointer size for fortran compilation
# If there's an issue compiling sizeptr, assume 8 byte (64 bit) pointers
PTRFILE = control/sizeptr.c
PTROBJ  = control/sizeptr.$(o_ext)
PTREXEC = control/sizeptr
PTRSIZE = $(shell if [ -x $(PTREXEC) ]; then $(PTREXEC); else echo 8; fi)
PTROPT  = -Dmagma_devptr_t="integer(kind=$(PTRSIZE))"

$(PTREXEC): $(PTROBJ)
	-$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $<
	touch $@

$(PTROBJ): $(PTRFILE)
	-$(CC) $(CFLAGS) -c -o $@ $<
	touch $@


# ------------------------------------------------------------------------------
# include sub-directories

# variables that multiple sub-directories add to.
# these MUST be := defined, not = defined, for $(cdir) to work.
hdr                  :=
libmagma_src         :=
libmagma_dynamic_src :=
testing_src          :=
libsparse_src        :=
libsparse_dynamic_src:=
sparse_testing_src   :=

subdirs := \
	blas_fix            \
	control             \
	include             \
	interface_cuda      \
	src                 \
	magmablas           \
	testing             \
	testing/lin         \
	sparse              \
	sparse/blas         \
	sparse/control      \
	sparse/include      \
	sparse/src          \
	sparse/testing      \

Makefiles := $(addsuffix /Makefile.src, $(subdirs))

include $(Makefiles)

-include Makefile.internal
-include Makefile.local
-include Makefile.gen


# ------------------------------------------------------------------------------
# objects

ifeq ($(FORT),)
    liblapacktest_all2 := $(filter     %_no_fortran.cpp, $(liblapacktest_all))
else
    liblapacktest_all2 := $(filter-out %_no_fortran.cpp, $(liblapacktest_all))
endif

ifeq ($(FORT),)
    libmagma_all := $(filter-out %.f %.f90 %.F90, $(libmagma_all))
    testing_all  := $(filter-out %.f %.f90 %.F90, $(testing_all))
endif

libmagma_obj       := $(addsuffix .$(o_ext), $(basename $(libmagma_all)))
libblas_fix_obj    := $(addsuffix .$(o_ext), $(basename $(libblas_fix_src)))
libtest_obj        := $(addsuffix .$(o_ext), $(basename $(libtest_all)))
liblapacktest_obj  := $(addsuffix .$(o_ext), $(basename $(liblapacktest_all2)))
testing_obj        := $(addsuffix .$(o_ext), $(basename $(testing_all)))
libsparse_obj      := $(addsuffix .$(o_ext), $(basename $(libsparse_all)))
sparse_testing_obj := $(addsuffix .$(o_ext), $(basename $(sparse_testing_all)))

ifneq ($(libmagma_dynamic_src),)
libmagma_dynamic_obj := $(addsuffix .$(o_ext),      $(basename $(libmagma_dynamic_all)))
libmagma_dlink_obj   := magmablas/dynamic.link.o
libmagma_obj         += $(libmagma_dynamic_obj) $(libmagma_dlink_obj)
endif

ifneq ($(libsparse_dynamic_src),)
libsparse_dynamic_obj := $(addsuffix .$(o_ext),      $(basename $(libsparse_dynamic_all)))
libsparse_dlink_obj   := sparse/blas/dynamic.link.o
libsparse_obj         += $(libsparse_dynamic_obj) $(libsparse_dlink_obj)
endif

deps :=
deps += $(addsuffix .d, $(basename $(libmagma_all)))
deps += $(addsuffix .d, $(basename $(libblas_fix_src)))
deps += $(addsuffix .d, $(basename $(libtest_all)))
deps += $(addsuffix .d, $(basename $(lapacktest_all2)))
deps += $(addsuffix .d, $(basename $(testing_all)))
deps += $(addsuffix .d, $(basename $(libsparse_all)))
deps += $(addsuffix .d, $(basename $(sparse_testing_all)))

# headers must exist before compiling objects, but we don't want to require
# re-compiling the whole library for every minor header change,
# so use order-only prerequisite (after "|").
$(libmagma_obj):       | $(header_all)
$(libtest_obj):        | $(header_all)
$(testing_obj):        | $(header_all)
$(libsparse_obj):      | $(header_all)
$(sparse_testing_obj): | $(header_all)

# changes to testings.h require re-compiling, e.g., if magma_opts changes
$(testing_obj):        testing/testings.h
$(libtest_obj):        testing/testings.h
$(sparse_testing_obj): testing/testings.h

# this allows "make force=force" to force re-compiling
$(libmagma_obj):       $(force)
$(libblas_fix_obj):    $(force)
$(libtest_obj):        $(force)
$(liblapacktest_obj):  $(force)
$(testing_obj):        $(force)
$(libsparse_obj):      $(force)
$(sparse_testing_obj): $(force)

force: ;


# ----- include paths
MAGMA_INC  = -I./include

$(libmagma_obj):       MAGMA_INC += -I./control
$(libtest_obj):        MAGMA_INC += -I./testing
$(testing_obj):        MAGMA_INC += -I./testing
$(libsparse_obj):      MAGMA_INC += -I./control -I./magmablas -I./sparse/include -I./sparse/control
$(sparse_testing_obj): MAGMA_INC += -I./sparse/include -I./sparse/control -I./testing


# ----- headers
# to test that headers are self-contained,
# pre-compile each into a header.h.gch file using "g++ ... -c header.h"
header_gch := $(addsuffix .gch, $(filter-out %.cuh, $(header_all)))

test_headers: $(header_gch)

%.h.gch: %.h
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c -o $@ $<


# ----- libraries
libmagma_a      := lib/libmagma.a
libmagma_so     := lib/libmagma.so
libblas_fix_a   := lib/libblas_fix.a
libtest_a       := testing/libtest.a
liblapacktest_a := testing/lin/liblapacktest.a
libsparse_a     := lib/libmagma_sparse.a
libsparse_so    := lib/libmagma_sparse.so

# static libraries
libs_a := \
	$(libmagma_a)		\
	$(libtest_a)		\
	$(liblapacktest_a)	\
	$(libblas_fix_a)	\
	$(libsparse_a)		\

# shared libraries
libs_so := \
	$(libmagma_so)		\
	$(libsparse_so)		\

# add objects to libraries
$(libmagma_a):      $(libmagma_obj)
$(libmagma_so):     $(libmagma_obj)
$(libblas_fix_a):   $(libblas_fix_obj)
$(libtest_a):       $(libtest_obj)
$(liblapacktest_a): $(liblapacktest_obj)
$(libsparse_a):     $(libsparse_obj)
$(libsparse_so):    $(libsparse_obj)

# sparse requires libmagma
$(libsparse_so): | $(libmagma_so)


# ----- testers
testing_c_src := $(filter %.c %.cpp,       $(testing_all))
testing_f_src := $(filter %.f %.f90 %.F90, $(testing_all))
testers       := $(basename $(testing_c_src))
testers_f     := $(basename $(testing_f_src))

=== testing/Makefile ===
# See Makefile.src for list of files in this directory.
# This makefile simply forwards commands to the top-level makefile.

top  := ..
pwd  := $(shell pwd)
cdir := $(notdir $(pwd))

default: $(cdir)

include $(top)/Makefile.subdir

=== sparse/blas/Makefile ===
# See Makefile.src for list of files in this directory.
# This makefile simply forwards commands to the top-level makefile.

top  := ../..
pwd  := $(shell pwd)
cdir := sparse/blas

default: $(cdir)

include $(top)/Makefile.subdir

=== debian/changelog ===
magma (2.5.4+ds-3) unstable; urgency=medium

  * Fix the broken symlinks due to missing Depends. (Closes: #985529)

 -- Mo Zhou <lumin@debian.org>  Thu, 25 Mar 2021 12:40:55 +0800

magma (2.5.4+ds-2) unstable; urgency=medium

  [ Andreas Beckmann ]
  * simplify cuda integration

  [ Mo Zhou ]
  * Add Turing and Ampere to the GPU_TARGET list.
  * Update my own mail address in d/control and d/copyright.

 -- Mo Zhou <lumin@debian.org>  Sun, 13 Dec 2020 17:35:25 +0800

magma (2.5.4+ds-1) unstable; urgency=medium

  * New upstream version 2.5.4
  * Remove unused symlinks from debian/ (Closes: #973802)
  * Rebase existing patches.
  * Patch makefiles to adjust GPU_TARGET to the supported ones.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Fri, 04 Dec 2020 11:00:29 +0800

magma (2.5.2+ds-1) experimental; urgency=medium

  * Initial release. (Closes: #941433)

 -- Mo Zhou <lumin@debian.org>  Thu, 23 Apr 2020 10:25:07 +0800

=== debian/control ===
Source: magma
Section: contrib/math
Homepage: https://icl.cs.utk.edu/magma/
Priority: optional
Standards-Version: 4.4.0
Vcs-Git: https://salsa.debian.org/science-team/magma.git
Vcs-Browser: https://salsa.debian.org/science-team/magma
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: debhelper-compat (= 12),
               gfortran,
               libopenblas-dev,
               nvidia-cuda-toolkit-gcc,
Build-Depends-Indep: doxygen

Package: libmagma2
Section: contrib/libs
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Matrix Algebra on GPU and Multicore Architectures (solib)
 The MAGMA project aims to develop a dense linear algebra library similar to
 LAPACK but for heterogeneous/hybrid architectures, starting with current
 "Multicore+GPU" systems.
 .
 The MAGMA research is based on the idea that, to address the complex challenges
 of the emerging hybrid environments, optimal software solutions will themselves
 have to hybridize, combining the strengths of different algorithms within a
 single framework. Building on this idea, we aim to design linear algebra
 algorithms and frameworks for hybrid manycore and GPU systems that can enable
 applications to fully exploit the power that each of the hybrid components
 offers.
 .
 This package contains the shared object libmagma.so.2

Package: libmagma-sparse2
Section: contrib/libs
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Matrix Algebra on GPU and Multicore Architectures (solib, sparse)
 The MAGMA project aims to develop a dense linear algebra library similar to
 LAPACK but for heterogeneous/hybrid architectures, starting with current
 "Multicore+GPU" systems.
 .
 The MAGMA research is based on the idea that, to address the complex challenges
 of the emerging hybrid environments, optimal software solutions will themselves
 have to hybridize, combining the strengths of different algorithms within a
 single framework. Building on this idea, we aim to design linear algebra
 algorithms and frameworks for hybrid manycore and GPU systems that can enable
 applications to fully exploit the power that each of the hybrid components
 offers.
 .
 This package contains the shared object libmagma_sparse.so.2

Package: libmagma-dev
Section: contrib/libdevel
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends},
 libmagma2 (= ${binary:Version}), libmagma-sparse2 (= ${binary:Version}),
Description: Matrix Algebra on GPU and Multicore Architectures (dev)
 The MAGMA project aims to develop a dense linear algebra library similar to
 LAPACK but for heterogeneous/hybrid architectures, starting with current
 "Multicore+GPU" systems.
 .
 The MAGMA research is based on the idea that, to address the complex challenges
 of the emerging hybrid environments, optimal software solutions will themselves
 have to hybridize, combining the strengths of different algorithms within a
 single framework. Building on this idea, we aim to design linear algebra
 algorithms and frameworks for hybrid manycore and GPU systems that can enable
 applications to fully exploit the power that each of the hybrid components
 offers.
 .
 This package contains the headers and the static libraries.

Package: libmagma-test
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Matrix Algebra on GPU and Multicore Architectures (tests)
 The MAGMA project aims to develop a dense linear algebra library similar to
 LAPACK but for heterogeneous/hybrid architectures, starting with current
 "Multicore+GPU" systems.
 .
 The MAGMA research is based on the idea that, to address the complex challenges
 of the emerging hybrid environments, optimal software solutions will themselves
 have to hybridize, combining the strengths of different algorithms within a
 single framework. Building on this idea, we aim to design linear algebra
 algorithms and frameworks for hybrid manycore and GPU systems that can enable
 applications to fully exploit the power that each of the hybrid components
 offers.
 .
 This package contains the test executables.

Package: libmagma-doc
Section: contrib/doc
Architecture: all
Depends: ${misc:Depends}
Description: Matrix Algebra on GPU and Multicore Architectures (doc)
 The MAGMA project aims to develop a dense linear algebra library similar to
 LAPACK but for heterogeneous/hybrid architectures, starting with current
 "Multicore+GPU" systems.
 .
 The MAGMA research is based on the idea that, to address the complex challenges
 of the emerging hybrid environments, optimal software solutions will themselves
 have to hybridize, combining the strengths of different algorithms within a
 single framework. Building on this idea, we aim to design linear algebra
 algorithms and frameworks for hybrid manycore and GPU systems that can enable
 applications to fully exploit the power that each of the hybrid components
 offers.
 .
 This package contains the Doxygen HTML documentation.

=== debian/watch ===
version=4
opts="repacksuffix=+ds, dversionmangle=s/\+ds\d*$//" \
https://icl.utk.edu/magma/software/index.html \
.*/magma-([\d.]*)\.tar\.gz debian uupdate
